
// GunnerM3G.java
// Andrew Davison, dandrew@fivedots.coe.psu.ac.th, November 2004

/* Your mission: find several penguins (more like sitting ducks
   really), and shoot them. 

   The camera includes a gun that can be fired, with nice visual
   and audio effects included. Most of the visuals are 2D images
   pasted onto simple meshes, not 3D models.

   GunnerM3G is the beginnings of a First Person Shooter (FPS).
*/

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;


public class GunnerM3G extends MIDlet
{
  private static final int PERIOD = 50;   // in ms

  private Timer timer;
  private GunnerCanvas gunnerCanvas = null;

  public GunnerM3G()
  { timer = new Timer();  
    gunnerCanvas = new GunnerCanvas(this); 
  }


  public void startApp() 
  { Display.getDisplay(this).setCurrent( gunnerCanvas );
    timer.schedule( new GunnerTimer(), 0, PERIOD);   // tick every PERIOD ms
  }
  
  public void pauseApp() {}

  public void destroyApp(boolean unconditional) {}

  public void finishGame()
  { timer.cancel();    // stop the timer
    notifyDestroyed();  
  }


  // -------------------------------------------

  class GunnerTimer extends TimerTask 
  {
    public void run() 
    { if(gunnerCanvas != null)
        gunnerCanvas.update();   // update the scene
    }
  }

} // end of GunnerM3G class
